/*

Arquivo:

   mem.hpp

Descrio:

   Permite a criao de ponteiros seguros, que so desalocados quando saem de
 escopo.

*/

#include <stdio.h>

//
// Classes
//
template<class T>
class mem_ptr {
  T* p;
  bool released;

public:
  /* Excees */
  class AllocationError { };

  /* Construtores e Destrutores */
  mem_ptr() : p(NULL), released(false) { };
  mem_ptr(T* q) : released(false)
    { if(q == NULL) throw AllocationError(); p = q; }
  mem_ptr(size_t s) : released(false)
    { p = new T[s]; if(p == NULL) throw AllocationError(); }
  ~mem_ptr() { if(!released) delete p; }

  /* Mtodos */
  void release() { released = true; }
  void lock() { released = false; }

  /* Operadores */
  void operator=(T* q)
    { if(q == NULL) throw AllocationError(); p = q; released = false; }
  operator T*() { return p; }
};
